#ifndef __FILTER_BASED_DISTRIBUTION
#define __FILTER_BASED_DISTRIBUTION

#include "SamplingStrategy.h"
#include "ObjectPvs.h"

namespace GtpVisibilityPreprocessor {

class FilterBasedDistribution: public SamplingStrategy
{
public:

  FilterBasedDistribution(Preprocessor &preprocessor)
	: SamplingStrategy(preprocessor)
  {
	mType = FILTER_BASED_DISTRIBUTION;
	mViewCell = NULL;
  }
  
private:
  
  virtual bool GenerateSample(SimpleRay &ray);

  // cached values
  ViewCell *mViewCell;
  ObjectPvs mFilteredPvs;
  int samplesToGenerate;
  int samplesGenerated;
  
  static HaltonSequence sHalton;
};
}

#endif
